package main

import (
	"code.byted.org/caijing_pay/tp_golang/tt_pay"
	"code.byted.org/caijing_pay/tp_golang/tt_pay/config"
	"context"
	"fmt"
	"github.com/gin-gonic/gin"
	"net/http"
)

var conf = config.Config{
	AppId:             "______________", // 支付方分配给业务方的ID，用于获取 签名/验签 的密钥信息
	AppSecret:         "_____________",  // 支付方密钥
	MerchantId:        "_____________",  // 支付方分配给业务方的商户编号
	TPDomain:          "https://tp-pay.snssdk.com",
	TPClientTimeoutMs: 6000,
}

func main() {
	r := gin.Default()

	r.POST("/trade_create_test", HandleTradeCreate)

	r.Run() // listen and serve on 0.0.0.0:8080
}

func HandleTradeCreate(c *gin.Context) {
	req := tt_pay.NewTradeCreateRequest(conf)
	req.Version = c.PostForm("version")
	req.OutOrderNo = c.PostForm("out_order_no")
	req.Uid = c.PostForm("uid")
	//req.TotalAmount = c.PostForm("total_amount")
	req.Currency = c.PostForm("currency")
	req.Subject = c.PostForm("subject")
	req.Body = c.PostForm("body")
	req.TradeTime = c.PostForm("trade_time")
	req.ValidTime = c.PostForm("valid_time")
	req.NotifyUrl = c.PostForm("notify_url")
	req.RiskInfo = c.PostForm("risk_info")
	req.CashdeskTradeType = c.PostForm("trade_type")
	ctx := context.Background()
	resp, err := tt_pay.TradeCreate(ctx, req)
	if err != nil {
		c.String(http.StatusOK, fmt.Sprintf("Request failed! \nRequest:\n  [%#v]\nError:\n  [%s]\n", req, err))
		return
	}
	cashDeskParams, _ := resp.GetCashdeskSdkParams()
	c.String(http.StatusOK, fmt.Sprintf("Request succeeded! \nRequest:\n [%#v]\nResponse:\n  [%#v]\nGet Cashdesk Parameters:\n  [%#v]\n", req, resp, cashDeskParams))
}
